:root {
  --default-background-color: #fff;
  --default-foreground-color: #000;
  --default-hover-background-color: #508eef;
  --default-hover-foreground-color: #fff;
  --dialog-background-color: var(--default-background-color);
  --dialog-border-color: #888;
  --dialog-footer-background-color: var(--dialog-header-background-color);
  --dialog-header-background-color: rgb(200, 200, 200);
  --dialog-header-forground-color: var(--default-foreground-color);
  --main-menu-bar-background-color: #adb5bf;
  --number-spinner-button-background-color: #fff;
  --number-spinner-button-fill-color: #fff;
  --number-spinner-button-hover-background-color: #ff0;
  --number-spinner-button-hover-fill-color: #000;
  --number-spinner-button-pressed-background-color: #ff0;
  --number-spinner-button-pressed-fill-color: #000;
  --popup-menu-background-color: #f9f9f9;
  --popup-menu-disabled-foreground-color: #aaa;
  --popup-menu-disabled-hover-background-color: #888;
  --popup-menu-disabled-hover-foreground-color: #aaa;
  --popup-menu-foreground-color: #333;
  --popup-menu-hover-background-color: #508eef;
  --popup-menu-hover-foreground-color: #fff;
  --popup-menu-selected-background-color: #4040ff;
  --primary-button-background-color: #4CAF50;
  --primary-button-disabled-background-color: #80aa80;
  --primary-button-hover-background-color: #6CCF80;
  --secondary-button-background-color: #869095;
  --secondary-button-disabled-background-color: #80aa80;
  --secondary-button-foreground-color: #fff;
  --secondary-button-hover-background-color: #b4c6c9;
  --secondary-button-hover-foreground-color: #ff0;
  --separator-color: #333;
  --shadow-color: rgba(0, 0, 0, 0.4);
  --table-header-background-color: rgb(200, 200, 200);
  --link-color: darkblue;
  --link-hover-color: blue;
}

@media (prefers-color-scheme: dark) {
  :root {
    --default-background-color: #3c3f41;
    --default-foreground-color: #bbb;
    --default-hover-background-color: #266acf;
    --default-hover-foreground-color: #fff;
    --dialog-background-color: var(--default-background-color);
    --dialog-border-color: #bbb;
    --dialog-footer-background-color: var(--dialog-header-background-color);
    --dialog-header-background-color: rgb(41, 49, 53);
    --dialog-header-forground-color: var(--default-foreground-color);
    --main-menu-bar-background-color: #191c23;
    --number-spinner-button-background-color: var(--default-background-color);
    --number-spinner-button-fill-color: var(--default-background-color);
    --number-spinner-button-hover-background-color: var(--default-background-color);
    --number-spinner-button-hover-fill-color: #bbb;
    --number-spinner-button-pressed-background-color: var(--default-background-color);
    --number-spinner-button-pressed-fill-color: #000;
    --popup-menu-background-color: #3e434c;
    --popup-menu-disabled-foreground-color: #666;
    --popup-menu-disabled-hover-background-color: #555;
    --popup-menu-disabled-hover-foreground-color: #888;
    --popup-menu-foreground-color: #fff;
    --popup-menu-hover-background-color: #266acf;
    --popup-menu-hover-foreground-color: #fff;
    --popup-menu-selected-background-color: #4040ff;
    --primary-button-background-color: #4c5052;
    --primary-button-disabled-background-color: #3c3f41;
    --primary-button-hover-background-color: #3f6b9c;
    --secondary-button-background-color: #596267;
    --secondary-button-disabled-background-color: #80aa80;
    --secondary-button-foreground-color: #bbb;
    --secondary-button-hover-background-color: #7b8bab;
    --secondary-button-hover-foreground-color: #ff0;
    --separator-color: #333;
    --shadow-color: rgba(0, 0, 0, 0.4);
    --table-header-background-color: rgb(41, 49, 53);
    --link-color: #6873a0;
    --link-hover-color: #93a2e0;
  }
}

/* Stuff needed for buttons and dialogs */
svg {
  fill: none;
  stroke: var(--default-foreground-color);
}

body {
  margin: 0;
  font-family: Arial, Helvetica, sans-serif;
  color: var(--default-foreground-color);
  background-color: var(--default-background-color);
}

article {
  padding: 20px;
}

a {
  color: var(--link-color);
}

a:hover {
  color: var(--link-hover-color);
}

/* Dialogs */

.modal-open {
  overflow: hidden;
}

.eni-dialog-header {
  flex: 0 0 auto;
  padding: 10px;
  background-color: var(--dialog-header-background-color);
}

.scrollable {
  overflow: auto;
}

.eni-dialog-content {
  overflow: auto;
  flex: 1 1 auto;
  display: flex;
  position: relative;
  align-items: center;
  justify-content: center;
  flex-direction: column;
  padding: 10px;
}

.eni-dialog-footer {
  flex: 0 0 auto;
  background-color: var(--dialog-footer-background-color);
}

.eni-modal {
  display: none;
  position: fixed;
  z-index: 100;
  left: 0;
  top: 0;
  width: 100vw;
  height: 100vh;
  overflow: hidden;
  background-color: var(--shadow-color);
  align-items: center;
  justify-content: center;
}

.eni-dialog {
  display: flex;
  flex-direction: column;
  padding: 0;
  overflow: hidden;
  border: 1px solid var(--dialog-border-color);
  background-color: var(--dialog-background-color);
  box-shadow: 5px 5px 3px var(--shadow-color);
  border-radius: 5px;
  max-height: calc(100% - 100px);
  max-width: calc(100% - 100px);
}

.toast {
  position: fixed;
  display: flex;
  flex-direction: column;
  padding: 0;
  overflow: hidden;
  border: 1px solid var(--dialog-border-color);
  background-color: var(--dialog-background-color);
  box-shadow: 5px 5px 3px var(--shadow-color);
  min-width: 50px;
  min-height: 20px;
  left: 50px;
  bottom: 0;
  opacity: 0;
  transition: bottom 0.5s ease-in, opacity 0.5s ease-in;
}

.tab-header {
  vertical-align: bottom;
  height: 41px;
  white-space: nowrap;
  overflow-x: auto;
  overflow-y: hidden;
}

.tab-container {
  display: flex;
  flex-direction: column;
  padding: 0;
  overflow: hidden;
}

.tab-header {
  flex: 0 0 auto;
}

.tab-content {
  overflow: auto;
  flex: 1 1 auto;
  display: block;
  position: relative;
}

.tab {
  top: 4px;
  vertical-align: middle;
  padding: 5px;
  height: 25px;
  position: relative;
  display: inline-block;
  border-top: 1px solid var(--dialog-border-color);
  border-top-left-radius: 4px;
  border-top-right-radius: 4px;
  border-left: 1px solid var(--dialog-border-color);
  border-right: 1px solid var(--dialog-border-color);
  transition: all 0.1s;
}

.tab.selected {
  top: 1px;
  height: 29px;
  background-color: var(--popup-menu-selected-background-color);
}

.tab:hover {
  background-color: var(--default-hover-background-color);
}


/* Pop-up menu */
.popup-blanket {
  position: fixed;
  left: 0;
  top: 0;
  width: 100vw;
  height: 100vh;
  z-index: 100;
  overflow: hidden;
}

.popup-menu {
  background-color: var(--popup-menu-background-color);
  box-shadow: 5px 5px 3px var(--shadow-color);
  position: absolute;
  max-width: 50vw;
  max-height: 80vh;
  overflow: auto;
  min-width: 20px;
  min-height: 20px;
  padding: 3px;
}

.popup-menu-entry {
  color: var(--popup-menu-foreground-color);
  padding: 12px 16px;
  text-decoration: none;
  display: block;
  text-align: left;
  cursor: pointer;
}

.popup-menu-entry.disabled {
  color: var(--popup-menu-disabled-foreground-color);
  cursor: not-allowed;
}

.popup-menu-entry.disabled:hover {
  color: var(--popup-menu-disabled-hover-foreground-color);
  background-color: var(--popup-menu-disabled-hover-background-color);
}

.popup-menu-entry.separator:hover,
.popup-menu-entry.separator {
  border-bottom: 1px solid var(--popup-menu-disabled-foreground-color);
  margin-top: 5px;
  margin-bottom: 5px;
  padding: 0;
}

.popup-menu-entry > * {
  vertical-align: middle;
}

.popup-menu-entry:hover {
  background: var(--popup-menu-hover-background-color);
  color: var(--popup-menu-hover-foreground-color);
}

.popup-menu-entry.selected {
  background: var(--popup-menu-selected-background-color);
  color: white;
}

/* default button */
input[type=submit]:disabled,
button:disabled {
  background-color: var(--primary-button-disabled-background-color);
  cursor: not-allowed;
}

input[type=submit]:disabled:hover,
button:disabled:hover {
  background-color: var(--primary-button-disabled-background-color);
  cursor: not-allowed;
}

input[type=submit],
.button,
button {
  transition-duration: 0.2s;
  background-color: var(--primary-button-background-color);
  border: none;
  color: white;
  padding: 10px 18px;
  margin: 2px;
  text-align: center;
  text-decoration: none;
  display: inline-block;
  min-width: 8em;
  font-size: 16px;
  cursor: default;
}

.button:hover,
button:hover {
  background-color: var(--primary-button-hover-background-color);
  box-shadow: 0 2px 4px 0 rgba(0, 0, 0, 0.16), 0 2px 10px 0 rgba(0, 0, 0, 0.12);
}

button.small {
  font-size: 11px;
  padding: 8px 10px;
}

.button.secondary,
button.secondary {
  transition-duration: 0.2s;
  background-color: var(--secondary-button-background-color);
  color: var(--secondary-button-foreground-color);
  border: none;
  padding: 5px 5px;
  margin: 2px;
  text-align: center;
  text-decoration: none;
  display: inline-block;
  min-width: 20px;
  font-size: 10px;
}

.button.secondary:hover,
button.secondary:hover {
  background-color: var(--secondary-button-hover-background-color);
  color: var(--secondary-button-hover-foreground-color);
  box-shadow: 0 2px 4px 0 rgba(0, 0, 0, 0.16), 0 2px 10px 0 rgba(0, 0, 0, 0.12);
}

.right {
  float: right;
}


label,
label > span {
  font-weight: 700;
  font-size: smaller;
  display: block;
}

.inline {
  display: inline;
}

/* Checkbox */

.checkbox input[type=checkbox] {
  visibility: hidden;
}

.checkbox {
  min-width: 25px;
  margin: 10px 10px;
  position: relative;
  display: inline-block;
}

.checkbox label {
  cursor: pointer;
  position: absolute;
  min-width: 25px;
  min-height: 25px;
  top: 0;
  left: 0;
  background: #eee;
  border: 1px solid #ddd;
}

.checkbox label > span {
  cursor: pointer;
  position: absolute;
  vertical-align: middle;
  top: 0;
  font-size: 25px;
  line-height: 25px;
  left: 35px;
  /*width: 300px;*/
}

.checkbox label:after {
  opacity: 0;
  content: '';
  position: absolute;
  width: 9px;
  height: 5px;
  background: transparent;
  top: 6px;
  left: 7px;
  border: 3px solid #333;
  border-top: none;
  border-right: none;
  transform: rotate(-45deg);
}

.checkbox input[type=checkbox]:checked + label:after {
  opacity: 1;
}

/* input fields */
select,
input {
  box-sizing: border-box;
  font-size: 12px;
  padding: 4px 4px;
  margin: 2px 2px 2px 2px;
  width: 150px;
}

input[type=file] {
  width: 300px;
}

.number-spinner-wrapper {
  display: flex;
  align-items: center;
  justify-content: center;
  flex-direction: row;
}

.number-spinner-wrapper input {
  width: 100px;
}

.number-spinner-wrapper.small input {
  width: 50px;
}

.number-spinner-button {
  display: inline-block;
  cursor: default;
  width: 20px;
  height: 20px;
}

.unit-selector {
  display: inline-block;
  cursor: default;
  min-width: 20px;
  height: 20px;
}

.unit-selector:hover {
  background-color: var(--number-spinner-button-background-color);
}

.number-spinner-button {
  background-color: var(--number-spinner-button-background-color);
}

.number-spinner-button:hover {
  background-color: var(--number-spinner-button-hover-background-color);
}

.number-spinner-button.pressed,
.number-spinner-button.pressed:hover {
  background-color: var(--number-spinner-button-pressed-background-color);
}

.number-spinner-button.pressed:hover svg,
.number-spinner-button.pressed svg {
  fill: var(--number-spinner-button-pressed-fill-color);
}

.number-spinner-button svg {
  fill: var(--number-spinner-button-fill-color);
}

.number-spinner-button:hover svg {
  fill: var(--number-spinner-button-hover-fill-color);
}

.number-spinner-button .icon-small {
  width: 20px;
  height: 20px;
  position: relative;
  display: inline-block;
}

/* Generic page structure */

.icon-small {
  width: 25px;
  height: 25px;
  position: relative;
  display: inline-block;
}

.card {
  padding: 10px;
  box-shadow: 0 2px 4px 0 rgba(0, 0, 0, 0.30), 0 2px 10px 0 rgba(0, 0, 0, 0.40);
  margin-bottom: 20px;
}

.page-body {
  display: flex;
  flex-direction: column;
  height: 100%;
}

.fixed-page-header {
  flex: 0 0 auto;
  padding: 0;
  box-shadow: 0 0 10px 2px #000;
  z-index: 2;
  display: flex;
  width: 100%;
  margin: 0;
  align-items: center;
}

.header-main {
  flex: 1 1 auto;
  display: flex;
  align-items: center;
}

.header-entry {
  display: inline-flex;
  align-items: center;
}

.icon-small {
  width: 25px;
  height: 25px;
  display: inline-flex;
}

.page-icon {
  width: 28px;
  height: 28px;
  flex: 0 0 auto;
  margin: 5px;
  /*display: inline-flex;*/
}

.icon-small-height {
  height: 28px;
}

.language-selector {
  /*align-self: flex-end;*/
  flex: 0 0 auto;
  /*width: 5em;*/
  padding: 5px;
}

.agb-footer {
  font-size: xx-small;
  display: flex;
  flex: 0 0 auto;
  align-content: center;
  align-items: center;
  justify-content: center;
  box-shadow: 0 0 10px 2px #000;
  z-index: 2;
}

.language-selector > div {
  padding-right: 3px;
}

.page-content {
  flex: 1 1 auto;
  overflow-y: auto;
  padding-top: 10px;
  position: relative;
}

.main-menu-bar {
  /*display: inline-block;*/
  cursor: default;
  background-color: var(--main-menu-bar-background-color);
}

.main-menu-entry {
  display: inline-block;
  cursor: default;
  min-width: 20px;
  height: 40px;
  line-height: 40px;
  padding-left: 5px;
  padding-right: 5px;
  vertical-align: top;
}

.main-menu-entry:hover {
  background-color: var(--popup-menu-hover-background-color);
}

table {
  border-collapse: collapse;
  margin: 0;
  padding: 0;
}

td, th {
  vertical-align: middle;
  border: 1px solid var(--separator-color);
  text-align: left;
  padding: 7px;
}

th {
  background: var(--table-header-background-color);
}

.right {
  text-align: right;
}

.center {
  text-align: right;
}

.space-right {
  margin-right: 5px;
}

.middle {
  vertical-align: middle;
}
